'*********************************************************************************
'**										**
'**		Script Name	:	PinItem.vbs				**
'**		Author		:	Y. BOUVIER / http://www.ciner.fr	**
'**		Version		:	1.0					**
'**		Updates		:	-					**
'**										**
'*********************************************************************************

'Skip on Error
On Error Resume Next

'Int Variable Declaration
Dim intLanguage

'String Variable Declaration
Dim strObjectToPin, filePath, strPinVerbTaskBarEN, strPinVerbStartMenuEN, strUnpinVerbTaskBarEN, strUnpinVerbStartMenuEN, strPinVerbTaskBarFR, strPinVerbStartMenuFR, strUnpinVerbTaskBarFR, strUnpinVerbStartMenuFR

'Bool Varaiable Declaration
Dim boolPin, boolLocation

'Object Varaiable Declaration
Dim objFSO, objShell, objArgs, objFile, objFolder, objFolderItem, objVerb

'Collection Varaiable Declaration
Dim colVerbs

'Creating Objects
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objShell = CreateObject("Shell.Application")
set objArgs = Wscript.Arguments

'Starting Code HERE

Select Case GetLocale()
        Case 1033 :
			strPinVerbStartMenu = "P&in to Start Menu"
			strUnpinVerbStartMenu = "Unp&in from Start menu"
			strPinVerbTaskBar = "P&in to Taskbar"
			strUnpinVerbTaskBar = "Unp&in from Taskbar"
		Case 1036 :
			strPinVerbStartMenu = "p&ingler au menu Dmarrer"
			strUnpinVerbStartMenu = "Dtacher du men&u Dmarrer"
			strPinVerbTaskBar = "pingler  la &barre des tches"
			strUnpinVerbTaskBar = "Dtacher de la b&arre des tches"
End Select

If (objArgs.count) then
    for i = 0 to objArgs.count - 1
        select case lcase(objArgs(i))
            case "-pin" : boolPin = true
            case "-unpin" : boolPin = false
			case "-taskbar" : boolLocation = true			
			case "-startmenu" : boolLocation = false
            case "-object" : strObjectToPin = objArgs(i + 1)
        end select
    next
	' Test Pin or Unpin parameter
	If not IsEmpty(boolPin) Then
		' Test Location parameter
		If not IsEmpty(boolLocation) Then
			' Test object parameter
			If not IsEmpty(strObjectToPin) Then
				' Test EXISTING object parameter
				If objFSO.FileExists(strObjectToPin) Then
					Set objFile = objFSO.GetFile(strObjectToPin)
					'Checking object parameter is .lnk file
					If RIGHT(UCASE(objFile.Path), 3) = "LNK" Then
						'All parameters are OK, so executing....
						filePath = objFile.ParentFolder
						Set objFolder = objShell.Namespace(filePath)
						Set objFolderItem = objFolder.ParseName(objFile.Name)
						Set colVerbs = objFolderItem.Verbs
						If boolPin Then
							' Action = Pin
							If boolLocation Then
								' Location = taskbar
								For Each objVerb in colVerbs
									If objVerb.name = strPinVerbTaskBar Then
										objVerb.DoIt
									End If
								Next
							Else
								' Location = startmenu
								For Each objVerb in colVerbs
									If objVerb.name = strPinVerbStartMenu Then
										objVerb.DoIt
									End If
								Next										
							End If
						Else
							' Action = Unpin
							If boolLocation Then
								' Location = taskbar
								For Each objVerb in colVerbs
									If objVerb.name = strUnpinVerbTaskBar Then
										objVerb.DoIt
									End If
								Next
							Else
								' Location = startmenu
								For Each objVerb in colVerbs
									If objVerb.name = strUnpinVerbStartMenu Then
										objVerb.DoIt
									End If
								Next										
							End If
						End If
					Else
						wscript.echo "Object MUST be a .lnk file to operate!"
					End If
				Else
					wscript.echo "Cannot find object : " & strObjectToPin
				End If
			Else
				wscript.echo "Object to pin not specified!"
			End If
		Else
			wscript.echo "startmenu or taskbar location not specified!"
		End If			
	Else
		wscript.echo "Pin or Unpin not specified!"
	End If
Else
    wscript.echo "You didn't pass any arguments!"
    wscript.echo "PinItem v1.0  Developped by Y. BOUVIER  CINER  http://www.ciner.fr"
    wscript.echo "Usage:"
    wscript.echo "cscript.exe PinItem.vbs -[pin|unpin] -[startmenu|taskbar] -object Path_To_Object.lnk"

End If
'Finishing Code HERE

'Destructing Objects

Set objFSO = Nothing
Set objShell = Nothing
Set objArgs = Nothing
Set objFile = Nothing
Set objFolder = Nothing
Set objFolderItem = Nothing
Set objVerb = Nothing
